No video

L5. Fruit Into Baskets | 2 Pointers and Sliding Window Playlist

  Рет қаралды 56,347

take U forward

take U forward

Күн бұрын

Notes/Codes/Problem links under step 10 of A2Z DSA Course: takeuforward.o...
Entire playlist: • Two Pointer and Slidin...
Follow us on our other social media handles: linktr.ee/take...

Пікірлер: 91
@ArjunAR06
@ArjunAR06 2 ай бұрын
I'm visiting this problem after a week (I solved this by watching striver's solution). I was not able to solve a single problem on my own thinking. I saw few comments stating that they were able to solve this by themselves and I was like "Am I doing something wrong. Why am I not able to solve on my own?" To my surprise, I completed the entire sliding window playlist and when I revisited after like a week, I'm able to solve every single sliding window problem in like 20 minutes. You deserve a huge salute, Striver!
@CleancodeCentral
@CleancodeCentral Ай бұрын
I used to have the Same problem manhh. Thats Normal. Complete the whole series or half of the problems. then take a problem and try to solve the problem on paper and pen. For some it takes only 50 leetcode problems But for some it takes More than 200 . " Consistency is the Key". keep improving...
@aryanjain9432
@aryanjain9432 23 күн бұрын
@@CleancodeCentral Tiru
@Sandeep-tn8mz
@Sandeep-tn8mz 5 ай бұрын
This was asked to me in AMAZON
@himanshu_047
@himanshu_047 4 ай бұрын
You got selected??
@Sandeep-tn8mz
@Sandeep-tn8mz 4 ай бұрын
@@himanshu_047 NO bro .. Im not from CS background so, my CS fundamentasl are not strong.. especially OSI, System design.. I was able to solve the current problem but messed up in system design problem.
@oppie335
@oppie335 4 ай бұрын
@@himanshu_047 he's here so , you know..
@Shivam-ux8mn
@Shivam-ux8mn 4 ай бұрын
Bhaiya mai abhi class 12 pass kiya haii aur abhi btech cse krne ka decide kiya hu and in jee mains meri 73 percentile bani aur abhi mai drop lu ya na lu ke doubt mw hu , ek point ye kehta hai ki college se zada skills matter krti hai agar tumhare pass skills hai to tumhari placement off campus bhi ho jayegi but ek taraf man me ye bhi hai ki kya ek baar try krna chhaiye , is taking a drop is worth it?
@Sandeep-tn8mz
@Sandeep-tn8mz 4 ай бұрын
Hey bro , At the end of the day your skills matter more than any college bro. Yes , the top tier colleges will give you that early career boost but its you who has to push yourself. Irrespective of college , if you keep yourself pushing you can do it from any college. yes you will have more difficulties , but they will definitely teach you a good lesson bro... ALL THE BEST (And if you are confident that you can do better by taking drop, go for it. You are still young, don't think much about outside noise. At the end of the day Its you who has to feed your family. )
@AkankshaGupta-zn7he
@AkankshaGupta-zn7he 5 ай бұрын
Just by watching & understanding the previous 4 videos, I was able to solve it on my own. First with brute then the sliding window technique. That's the magic of Striver😃❤
@jimit2795
@jimit2795 2 ай бұрын
how did you come to know that you have to use map or set in it.
@darkistheknight
@darkistheknight 2 ай бұрын
@@jimit2795 Look I am a noob myslef, but consider this, wherever we have to maintain something in terms of numbers like k distinct, at most k, you should know it is gonna be map. Here also we have two baskets i.e. we can store maximum of two types and we have to maximize the numbers of those 2 types of fruits. So at most K type questions. Hence map/set. That's all there's to it. Don't worry keep grinding. You'll get it.
@TheAditya-zt9pb
@TheAditya-zt9pb Ай бұрын
@@darkistheknight exactly your intuition is similar to mine
@selviraghavi-jp4ep
@selviraghavi-jp4ep 3 ай бұрын
This question was asked in infosys specialist programmer role and bro made a video thankfully :)
@user-bf7yz3qd2i
@user-bf7yz3qd2i 4 ай бұрын
This was asked to me in Adobe.
@shankarrakh7744
@shankarrakh7744 Ай бұрын
(best solution without using map) int totalFruits(int N, vector &fruits) { int f = -1; // first fruit type int s = -1; // second fruit type int l = 0; // left pointer int r = 0; // right pointer int ans = 0; while (r < N) { if (f == -1 || fruits[r] == fruits[f]) { f = r; } else if (s == -1 || fruits[r] == fruits[s]) { s = r; } else { // When a new fruit type is encountered if (f < s) { l = f + 1; f = r; } else { l = s + 1; s = r; } } ans = max(ans, r - l + 1); r++; } return ans; }
@raghavmanish24
@raghavmanish24 2 ай бұрын
hey striver you make things so simple , some time i got jealous that some others also can know this method from this videos ........thanku again striver
@rajharsh3739
@rajharsh3739 5 ай бұрын
I just solved before seeing this video by just copy paste the last code from L4 and did some tweaks. 🙌🙌
@hashcodez757
@hashcodez757 3 күн бұрын
"UNDERSTOOD BHAIYA!!"
@jagansubramanian5234
@jagansubramanian5234 5 ай бұрын
You made my DSA journey easy
@2amCoder
@2amCoder 5 ай бұрын
althugh i have alredy did all these patterns questions stii here for your support ! thanks a lot for that dp and graph series and others too.
@nishantshrivastava8937
@nishantshrivastava8937 2 ай бұрын
Theoretically, we have optimised the solution to O(n) but the solution of O(2N) is faster on runtime while programming.
@deepakvajpayee2396
@deepakvajpayee2396 4 ай бұрын
This solution can also be optimised by in place of storing count of the character in map if we store last index of the character
@AK-nj1je
@AK-nj1je Ай бұрын
Actually the space complexity of the most optimal approach will be almost O(n) Coz just imagine all the elements are different then, the code will not care what's the size of the map, it will just keep adding elements in the map, howeven the maxlen will not be affected. Amazing lecture!!!!
@shubhtandon8315
@shubhtandon8315 Ай бұрын
Right!!! but suppose the array has half no. of elements as of type 1 and the rest of the array has different types(2,3,4,.....) then while trimming down the left side we will be adding different elements to the map. So instead of O(n), it can said to be near about O(maxlen ) or O(n/2) as at max we will be storing half of the elements. What do you say?
@Aparichi78gft
@Aparichi78gft 24 күн бұрын
No bro map will not store the let say 1--- element rather it will store the entry of it so it will o(1) not o(n/2) so at max map will be o(3).
@akashwasson4220
@akashwasson4220 3 ай бұрын
Striver bro you are a pro....Salute!
@watch2-grow
@watch2-grow 5 күн бұрын
Understood thanks bhaiya
@Captionamerica
@Captionamerica Ай бұрын
Bhai saaahab tussi great ho ❤❤❤❤. A big hearts to you bade bhaiyaaa
@stith_pragya
@stith_pragya 4 ай бұрын
UNDERSTOOD...Thank You So Much for this wonderful video.......🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@Ethical-Boy-No-1
@Ethical-Boy-No-1 5 ай бұрын
28:58 I have a question bhaiya .. Let's take this example {1,2,1,2,1,2,1,2,3,4,5,6,7,8,9,10,11} .. if you see in case of optimal solution then SC=O(n/2) for map ... so how it is O(1) . And if you make an example of 10^5 length array the same as the upper example then also SC=O(10^5/2)..
@fizzgaming7910
@fizzgaming7910 2 ай бұрын
Pointing out a small error, instead of erasing mpp[arr[l]] in the code, erase arr[l] and the code works flawlessly
@soumeshnayak4546
@soumeshnayak4546 2 ай бұрын
I was unable to solve a single question in Sliding Window and two pointers after watching the above concepts I can think of and able to solve this question. This is the solution that I have solved on my own. def totalFruit(self, fruits: List[int]) -> int: maxlen=0 map={} i=0 for j in range(len(fruits)): map[fruits[j]]=map.get(fruits[j],0)+1 while len(map)>2: map[fruits[i]]-=1 if map[fruits[i]]==0: del map[fruits[i]] i+=1 if len(map)
@takagaminggxd
@takagaminggxd Ай бұрын
beautiful explanation ❤
@sahulraj9536
@sahulraj9536 29 күн бұрын
for optimal approach space complexity cant be O(1) right, because map can have more than 2 elements as well for this example {1,1,1,1,1,3,3,2,4,5,6,7,8,9} for the above example map can have almost n/2 elements correct me if im wrong
@Aparichi78gft
@Aparichi78gft 24 күн бұрын
No bro map will have at max 3 elements in any case
@verma_jay
@verma_jay 7 сағат бұрын
You are correct
@user-fz1tl2dh9b
@user-fz1tl2dh9b Ай бұрын
lovee you brooo thanksss a lott!!!
@sonakshibajpai6445
@sonakshibajpai6445 2 ай бұрын
Thank you striver !!
@AtulSingh-dp8wo
@AtulSingh-dp8wo 5 ай бұрын
most awaited ❤thanks a lot!
@RadheShyam33455
@RadheShyam33455 4 күн бұрын
tried using set instead of hashset and directly removing(arr[i]) from set and setting i=j-1; whenever setSize >2 but it failed certain test cases
@anshkothariAK
@anshkothariAK 3 күн бұрын
Your code will not work for this testcase: {1, 2, 1, 2, 3, 2, 2, 1}
@oyeesharme
@oyeesharme 16 күн бұрын
understood bhaiya
@Abcd-jt1qs
@Abcd-jt1qs 2 ай бұрын
Understood sir! Thank you :)
@augustinradjou3909
@augustinradjou3909 5 ай бұрын
Understood bhaiya ❤
@namannema3349
@namannema3349 4 ай бұрын
thanks striver
@techmatein
@techmatein Ай бұрын
i think i solved it in better way : class Solution { public: int totalFruit(vector& fruits) { pairp1={-1,-1}; pairp2={-1,-1}; int l=0; int ans=-1; for(int i=0;i
@shivisingh9975
@shivisingh9975 4 ай бұрын
Understood sir!
@subee128
@subee128 5 ай бұрын
thanks
@adityapandey23
@adityapandey23 Ай бұрын
Understood
@AJ-ve1yb
@AJ-ve1yb 4 ай бұрын
should i follow sequence of this playlist according to a2z sheet or to watch first which has been uploaded first @striver
@raghavmanish24
@raghavmanish24 2 ай бұрын
understood
@lucifee9407
@lucifee9407 3 ай бұрын
Striver if you are the interviewer ,you ask to optimize it to 2N to N ??
@Harsh-jc2bz
@Harsh-jc2bz 3 ай бұрын
mostly dont ask...9 out of 10
@5Q8NAZEER
@5Q8NAZEER 12 күн бұрын
we should erase mp.erase(arr[l]) not mp.erase(mp[arr[l]]) ...... a small correction from my side
@akworld2739
@akworld2739 3 ай бұрын
but i am happy with 0(2N) time complexity😂😂😂😂
@techmatein
@techmatein Ай бұрын
after solving the previous question on my own and reading this one, i thought i could not be able to solve this one on my own but gave it a try and solved it on my own and that also in just o(n). quite happy today.
@alessandrocamilleri1239
@alessandrocamilleri1239 4 ай бұрын
Great explanation as usual. However the map is actually not necessary. int findMaxFruits(vector &arr, int n) { int fruit1 = arr[0], fruit2 = -1; int nextLeftPos = -1; int l = 0, r = 1; int count = 1; while (r < n) { if (arr[r] == fruit1 || arr[r] == fruit2) { if(arr[r] != arr[r-1]) nextLeftPos = r; count = max(count, r - l + 1); r++; } else if (fruit2 == -1) { fruit2 = arr[r]; nextLeftPos = r; count = max(count, r - l + 1); r++; } else { l = nextLeftPos; fruit1 = arr[l]; fruit2 = arr[r]; } } return count; }
@saketjaiswal9381
@saketjaiswal9381 4 ай бұрын
done
@noone-fl1qb
@noone-fl1qb 4 ай бұрын
Can anyone tell me why this is 'nt working int findMaxFruits(vector &arr, int n) { int left = 0, right = 0, maxLength = 0; unordered_map map; while (right < arr.size()) { map[arr[right]]++; if (map.size() > n) { map[arr[left]]--; if (map[arr[left]] == 0) { map.erase(arr[left]); } left++; } if(map.size()
@shubhiiii220
@shubhiiii220 3 ай бұрын
Add "right++" after closing the bracket of "if(map.size()
@ayushisingh6638
@ayushisingh6638 3 ай бұрын
If this is geeksforgeesks question the varibale n is the size of array. if questio says 2 basket then you need to use 2 instead of n the following will produce correct result: int totalFruits(int n, vector &arr) { int left = 0, right = 0, maxLength = 0; unordered_map map; while (right < n) { map[arr[right]]++; if (map.size() > 2) { map[arr[left]]--; if (map[arr[left]] == 0) { map.erase(arr[left]); } left++; } maxLength = max(maxLength, right - left + 1); right++; } return maxLength; }
@hardiksingh8344
@hardiksingh8344 4 ай бұрын
thanks sir can you update in take you forward site as well
@txbankush4601
@txbankush4601 2 ай бұрын
can anyone provide me the full code because my some testcases are not being passed according to this pseudocode
@simarpreetsingh7235
@simarpreetsingh7235 28 күн бұрын
A better method could be storing {value, last picked position} , since only two values would be there in the map pick the minimum of last picked position of the two, O(N) solution
@shreerangaraju1013
@shreerangaraju1013 3 ай бұрын
Can anyone tell me what iPad software is striver using?
@harshit779
@harshit779 4 ай бұрын
bahaiya please upload article on the website for this
@user-oj3wh8bx8z
@user-oj3wh8bx8z 5 ай бұрын
Please add C++ code also
@parvahuja7618
@parvahuja7618 5 ай бұрын
then what will you do
@sangharshpipare666
@sangharshpipare666 4 ай бұрын
@@parvahuja7618 I will dance
@ramdangi5335
@ramdangi5335 4 ай бұрын
@@parvahuja7618 nagin dance 😂😂
@lakshsinghania
@lakshsinghania 3 ай бұрын
do it yourself bro
@angeldeveloper
@angeldeveloper 5 ай бұрын
🙌🏻
@user-gk4zy6bk7l
@user-gk4zy6bk7l 3 ай бұрын
god
@Beeplov2337568
@Beeplov2337568 5 ай бұрын
😍
@angeldeveloper
@angeldeveloper 5 ай бұрын
❤🙌🏻👍
@rohanbera6227
@rohanbera6227 11 күн бұрын
int totalFruits(vector arr) { int n = arr.size(); if (n == 1) return 1; int i = 0, j = 0, maxi = 0; int elem1 = arr[0], elem2 = -1; int ind1 = 0, ind2 = 0; int lastConsec = 0; while (j < n) { if (elem2 != -1 && elem1 != arr[j] && elem2 != arr[j]) { i = lastConsec; elem1 = arr[i]; elem2 = arr[j]; } elem2 = (elem1 != arr[j] && elem2 == -1) ? arr[j] : elem2; if (arr[j] != arr[lastConsec]) lastConsec = j; maxi = max(maxi, j - i + 1); j++; } return maxi; }
@yashwanthkumar2513
@yashwanthkumar2513 3 ай бұрын
+1
@rlm3227
@rlm3227 2 ай бұрын
understood
@shailesh_rajpurohit
@shailesh_rajpurohit 5 ай бұрын
understood
@ramakrishnakcr4417
@ramakrishnakcr4417 5 ай бұрын
understood
Ik Heb Aardbeien Gemaakt Van Kip🍓🐔😋
00:41
Cool Tool SHORTS Netherlands
Рет қаралды 9 МЛН
王子原来是假正经#艾莎
00:39
在逃的公主
Рет қаралды 19 МЛН
English or Spanish 🤣
00:16
GL Show
Рет қаралды 9 МЛН
L4. Max Consecutive Ones III | 2 Pointers and Sliding Window Playlist
29:58
LeetCode | 904. Fruit Into Baskets | Sliding Window
16:37
The LeetCode Fallacy
6:08
NeetCode
Рет қаралды 484 М.
How I would learn Leetcode if I could start over
18:03
NeetCodeIO
Рет қаралды 467 М.
Launching the best DSA Course + Platform
36:29
take U forward
Рет қаралды 201 М.
L12. Minimum Window Substring | 2 Pointers and Sliding Window Playlist
27:06
My Brain after 569 Leetcode Problems
7:50
NeetCode
Рет қаралды 2,5 МЛН
Ik Heb Aardbeien Gemaakt Van Kip🍓🐔😋
00:41
Cool Tool SHORTS Netherlands
Рет қаралды 9 МЛН